﻿Imports ThinkGeo.MapSuite.WebEdition
Imports ThinkGeo.MapSuite.Core

Partial Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim googleOverlayer As GoogleOverlay = New GoogleOverlay("google", GoogleMapType.Hybrid)
        googleOverlayer.IsVisible = True

        Me.Map1.MapUnit = ThinkGeo.MapSuite.Core.GeographyUnit.Meter
        Me.Map1.CustomOverlays.Add(googleOverlayer)
        Me.Map1.MapTools.OverlaySwitcher.Enabled = True
        Me.Map1.ActiveBaseOverlay = googleOverlayer
        LoadAMapFromMsSQL2008()
        LoadAMapFromMsSQL2008_2()
    End Sub

    Private Sub LoadAMapFromMsSQL2008()
        Dim connectString As String = ConfigurationManager.ConnectionStrings("SQLServer").ConnectionString

        CreateStaticTest()

        Dim sql2008Layer As New MsSql2008FeatureLayer(connectString, "v_test", "id")
        Dim myOverLayer As New LayerOverlay("sql", False, TileType.SingleTile)
        sql2008Layer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Highway1
        sql2008Layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        myOverLayer.Layers.Add(sql2008Layer)
        Map1.CustomOverlays.Add(myOverLayer)
    End Sub

    Private Sub CreateStaticTest()
        Dim con As SqlClient.SqlConnection = New SqlClient.SqlConnection(ConfigurationManager.ConnectionStrings("SQLServer").ConnectionString)
        Dim cmd As SqlClient.SqlCommand = con.CreateCommand()
        con.Open()

        Dim strDrop As String = "  IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[geometrytest]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT')) DROP FUNCTION [dbo].[geometrytest]"
        cmd.CommandText = strDrop

        cmd.ExecuteScalar()
        cmd.CommandText = "IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[v_test]')) DROP VIEW [dbo].[v_test]"
        cmd.ExecuteScalar()

        Dim strCreatFunction As String = "CREATE FUNCTION [dbo].[geometrytest]() RETURNS Geometry AS BEGIN " & _
                                         "DECLARE @wktstring VARCHAR(MAX);" & _
                                         "DECLARE @result GEOMETRY;" & _
                                         "SET @wktstring = 'LINESTRING (-9.1656818389893 38.7097587585449,-9.1499023437500 38.5828857421875,-9.1199350357056 38.6249618530273)'" & _
                                         "SET @result = geometry::STLineFromText(@wktstring, 0).MakeValid()" & _
                                         "return @result " & _
                                         "END"
        cmd.CommandText = strCreatFunction
        cmd.ExecuteScalar()
        Dim strCreateView As String = "CREATE VIEW [dbo].[v_test] AS SELECT '1' AS id, dbo.geometrytest() AS Geometry"
        cmd.CommandText = strCreateView
        cmd.ExecuteScalar()
        con.Close()
    End Sub


    Private Sub LoadAMapFromMsSQL2008_2()
        Dim connectString As String = ConfigurationManager.ConnectionStrings("SQLServer").ConnectionString

        CreateStaticTest_2()

        Dim sql2008Layer As New MsSql2008FeatureLayer(connectString, "v_test_2", "id")
        Dim myOverLayer As New LayerOverlay("sql_2", False, TileType.SingleTile)
        sql2008Layer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Highway1
        sql2008Layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
        myOverLayer.Layers.Add(sql2008Layer)
        Map1.CustomOverlays.Add(myOverLayer)
    End Sub

    Private Sub CreateStaticTest_2()
        Dim con As SqlClient.SqlConnection = New SqlClient.SqlConnection(ConfigurationManager.ConnectionStrings("SQLServer").ConnectionString)
        Dim cmd As SqlClient.SqlCommand = con.CreateCommand()
        con.Open()

        Dim strDrop As String = "  IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[geometrytest_2]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT')) DROP FUNCTION [dbo].[geometrytest_2]"
        cmd.CommandText = strDrop

        cmd.ExecuteScalar()
        cmd.CommandText = "IF  EXISTS (SELECT * FROM sys.views WHERE object_id = OBJECT_ID(N'[dbo].[v_test_2]')) DROP VIEW [dbo].[v_test_2]"
        cmd.ExecuteScalar()

        Dim strCreatFunction As String = "CREATE FUNCTION [dbo].[geometrytest_2]() RETURNS Geometry AS BEGIN " & _
                                         "DECLARE @wktstring VARCHAR(MAX); " & _
                                         "DECLARE @result GEOMETRY; " & _
                                         "SET @wktstring = 'LINESTRING (-9.1656818389893 38.7097587585449,-9.1499023437500 38.5828857421875,-9.1199350357056 38.6249618530273)' " & _
                                         "SET @result = geometry::STLineFromText(@wktstring, 0).MakeValid() " & _
                                         "return @result " & _
                                         "END"

       
        cmd.CommandText = strCreatFunction
        cmd.ExecuteScalar()
        Dim strCreateView As String = "CREATE VIEW [dbo].[v_test_2] AS SELECT '1' AS id, GEOGRAPHY::STGeomFromWKB(dbo.geometrytest_2().STAsBinary(), 4326) AS Geometry"
        cmd.CommandText = strCreateView
        cmd.ExecuteScalar()
        con.Close()
    End Sub
End Class